/**
 * Ce code fait partie des programmes d'exemple du cours de zttique
 * de l'Universit de Paris-Est Marne-la-Valle.
 *  
 *
 * Copyright (C) Universit Paris-Est Marne-la-Valle
 * @author Sebastien Paumier (paumier@univ-mlv.fr)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 *
 */
package fr.umlv.zetetique.bible;

public class Index {

	int[][] t;
	
	public Index(StringBuilder builder) {
		int[] lengthes=computeLengthes(builder);
		t=new int[26][];
		int i;
		for (i=0;i<26;i++) {
			t[i]=new int[lengthes[i]];
			lengthes[i]=0;
		}
		int length=builder.length();
		for (i=0;i<length;i++) {
			char c=builder.charAt(i);
			int pos=lengthes[c-'A'];
			t[c-'A'][pos]=i;
			lengthes[c-'A']++;
		}
	}

	
	private int[] computeLengthes(StringBuilder builder) {
		int[] z=new int[26];
		int i;
		for (i=0;i<26;i++) {
			z[i]=0;
		}
		int l=builder.length();
		for (i=0;i<l;i++) {
			z[builder.charAt(i)-'A']++;
		}
		return z;
	}
	
	
	public int[] getIndices(char c) {
		if (c<'A' || c>'Z') return null;
		return t[c-'A'];
	}
	
	
	public int getLowestFreqLetterIndex(String word) {
		int n=-1;
		int pos=-1;
		for (int i=0;i<word.length();i++) {
			if (n==-1 || t[word.charAt(i)-'A'].length<n) {
				n=t[word.charAt(i)-'A'].length;
				pos=i;
			}
		}
		return pos;
	}
}
