/**
 * Ce code fait partie des programmes d'exemple du cours de zttique
 * de l'Universit de Paris-Est Marne-la-Valle.
 *  
 *
 * Copyright (C) Universit Paris-Est Marne-la-Valle
 * @author Sebastien Paumier (paumier@univ-mlv.fr)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 *
 */
package fr.umlv.zetetique.bible;

import java.awt.event.*;

import javax.swing.*;

@SuppressWarnings("serial")
public class ProphecyPanel extends JPanel {

	Prophecy prophecy;
	int[] current;
	CodeGrid codeGrid;
	
	public ProphecyPanel(Prophecy prophecy,CodeGrid codeGrid) {
		super(null);
		setLayout(new BoxLayout(this,BoxLayout.X_AXIS));
		this.prophecy=prophecy;
		this.codeGrid=codeGrid;
		current=new int[prophecy.secondWords.size()];
		for (int i=0;i<current.length;i++) {
			JPanel p=new JPanel(null);
			p.setLayout(new BoxLayout(p,BoxLayout.Y_AXIS));
			GridWord gw=prophecy.secondWords.get(i);
			ButtonGroup bg=new ButtonGroup();
			for (int j=0;j<gw.positions.size();j++) {
				JToggleButton button=new JToggleButton(gw.word);
				button.setSelected(j==0);
				final int ii=i;
				final int jj=j;
				button.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						current[ii]=jj;
						refresh();
					}});
				p.add(button);
				bg.add(button);
			}
			add(p);
		}
		refresh();
	}
	
	public void refresh() {
		codeGrid.display(prophecy.grid);
		codeGrid.highlightWord(0,prophecy.mainWord.word,prophecy.mainCoordinates);
		for (int i=0;i<current.length;i++) {
			GridWord gw=prophecy.secondWords.get(i);
			codeGrid.highlightWord(i+1,gw.word,gw.positions.get(current[i]));
		}
		codeGrid.refreshGlassPane();
	}
}
