/**
 * Ce code fait partie des programmes d'exemple du cours de zttique
 * de l'Universit de Paris-Est Marne-la-Valle.
 *  
 *
 * Copyright (C) Universit Paris-Est Marne-la-Valle
 * @author Sebastien Paumier (paumier@univ-mlv.fr)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 *
 */
package fr.umlv.zetetique.brown;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;

import javax.swing.*;

public class Brown1D {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		JFrame f=new JFrame("Mouvement brownien 1D - http://zetetique.univ-mlv.fr");
		f.setSize(800,800);
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		final MyPanel p=new MyPanel();
		f.getContentPane().add(p);
	    JButton change= new JButton("Changer");
	    change.addActionListener(new ActionListener() {
	        public void actionPerformed(ActionEvent arg0) {
	            p.drawBrownMovement();
	            p.repaint();
	         }
	      });
	   f.getContentPane().add(change,BorderLayout.NORTH);
	   f.getContentPane().add(p);
	   f.setVisible(true);
	}

	

	@SuppressWarnings("serial")
	public static class MyPanel extends JComponent {
	      final static BufferedImage image=
	         new BufferedImage(800, 800, BufferedImage.TYPE_INT_ARGB);

	      final static Random rand= new Random();

	      public MyPanel() {
	         super();
	         drawBrownMovement();
	      }
	      ActionListener l=new ActionListener() {
	         public void actionPerformed(ActionEvent arg0) {
	            Graphics g= image.getGraphics();
	            g.setColor(new Color(rand.nextInt()));
	            int n=400;
	            for (int i=100;i<700; i++) {
	            	n=n+(rand.nextInt(21)-10);
	            	g.drawLine(i,400,i,n);
	            }
	            g.setColor(Color.BLACK);
            	g.drawLine(50,400,700,400);
            	g.drawLine(100,200,100,600);
            	g.setFont(new Font("Courier New",0,40));
            	g.drawString("0",75,390);
            	g.drawString("200",25,227);
            	g.drawString("-200",2,600);
            	g.drawString("600",670,435);
            	g.drawString("moyenne="+(float)(400.0-n)/600,250,200);
	            repaint();
	         }
	      };

	      void drawBrownMovement() {
	         Graphics g= image.getGraphics();
	         g.setColor(Color.WHITE);
	         g.fillRect(0, 0, image.getWidth(), image.getHeight());
	         l.actionPerformed(null);
	      }

	      @Override
		protected void paintComponent(Graphics g) {
	         super.paintComponent(g);
	         g.drawImage(image, 0, 0, null);
	      }

	      @Override
		public Dimension getPreferredSize() {
	         return new Dimension(image.getWidth(), image.getHeight());
	      }

	   }
	
	
}
