/**
 * Ce code fait partie des programmes d'exemple du cours de zttique
 * de l'Universit de Paris-Est Marne-la-Valle.
 *  
 *
 * Copyright (C) Universit Paris-Est Marne-la-Valle
 * @author Sebastien Paumier (paumier@univ-mlv.fr)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 *
 */
package fr.umlv.zetetique.brown;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;
import javax.swing.*;


public class Brown2D {

   final static JFrame f= new JFrame("Mouvement brownien 2D - http://zetetique.univ-mlv.fr");

   public static void main(String[] args) {
      final BrownMovementPanel panel= new BrownMovementPanel();
      f.getContentPane().add(panel);
      JButton change= new JButton("Changer");
      change.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent arg0) {
            panel.drawBrownMovement();
            panel.repaint();
         }
      });

      f.getContentPane().add(change, BorderLayout.NORTH);
      f.pack();
      f.setResizable(false);
      f.setVisible(true);
      f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
   }

   @SuppressWarnings("serial")
public static class BrownMovementPanel extends JComponent {
      final static BufferedImage image=
         new BufferedImage(800, 800, BufferedImage.TYPE_INT_ARGB);

      final static Random rand= new Random();

      public BrownMovementPanel() {
         super();
         drawBrownMovement();
      }

      int oldX= image.getWidth() / 2, oldY= image.getHeight() / 2;
      int n= 0;

      ActionListener l=new ActionListener() {
         public void actionPerformed(ActionEvent arg0) {
            Graphics g= image.getGraphics();
            int X, Y;
            g.setColor(new Color(rand.nextInt()));
            for (int i= 0; i < 100000; i++) {
               n++;
               X= oldX + rand.nextInt(3) - 1;
               Y= oldY + rand.nextInt(3) - 1;
               g.drawLine(oldX, oldY, X, Y);
               oldX= X;
               oldY= Y;
            }
            /*f
               .setTitle(
                  "n="
                     + n
                     + "  sqrt(n)="
                     + (int)Math.sqrt(n)
                     + "   distance="
                     + (int)Math.sqrt(
                        (image.getWidth() / 2 - oldX)
                           * (image.getWidth() / 2 - oldX)
                           + (image.getHeight()/2- oldY) * (image.getHeight()/2- oldY))
                           +"   rapport="+Math.sqrt(
            (image.getWidth() / 2 - oldX)
               * (image.getWidth() / 2 - oldX)
               + (image.getHeight()/2- oldY) * (image.getHeight()/2- oldY))/Math.sqrt(n));*/
            g.setColor(Color.RED);
            g.fillOval(
               image.getWidth() / 2 - 5,
               image.getHeight() / 2 - 5,
               10,
               10);
            repaint();
         }
      };

      void drawBrownMovement() {
         Graphics g= image.getGraphics();
         g.setColor(Color.WHITE);
         g.fillRect(0, 0, image.getWidth(), image.getHeight());
         oldX= image.getWidth() / 2;
         oldY= image.getHeight() / 2;
         n= 0;
         l.actionPerformed(null);
      }

      @Override
	protected void paintComponent(Graphics g) {
         super.paintComponent(g);
         g.drawImage(image, 0, 0, null);
      }

      @Override
	public Dimension getPreferredSize() {
         return new Dimension(image.getWidth(), image.getHeight());
      }

   }

}
