/**
 * Ce code fait partie des programmes d'exemple du cours de zttique
 * de l'Universit de Paris-Est Marne-la-Valle.
 *  
 *
 * Copyright (C) Universit Paris-Est Marne-la-Valle
 * @author Julien Cervelle (jcervell@univ-mlv.fr)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 *
 */
package fr.umlv.zetetique.illusions;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.SourceDataLine;

public class ShepardTones {
  public static double K = Math.exp(Math.log(2.)/12.);
  public static double FREQ = 44100.D;
  public static double A_NOTE = 110.D;

  private static void putByte(byte[] b, int offset, double val) {
    short s = (short)(val*Short.MAX_VALUE);
    b[offset+1] =  ((byte)(s>>8));
    b[offset] = ((byte)(s&0xFF));
  }

  public static void main(String[] args) throws LineUnavailableException, InterruptedException {
	JFrame f=new JFrame("Shepard's tones - http://zetetique.univ-mlv.fr");
	f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	Container p=f.getContentPane();
	p.add(new JLabel(" Ce programme prsente une illusion sonore. N'oubliez pas d'allumer vos enceintes. "));
	JButton button=new JButton("Quitter");
	button.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			System.exit(0);
		}
  	});
	p.add(button,BorderLayout.EAST);
	f.pack();
	f.setVisible(true);
	
    SourceDataLine line = null;
    AudioFormat fmt = new AudioFormat(
        AudioFormat.Encoding.PCM_SIGNED,
        44100.0F, 16, 1, 2, 44100.0F, false);
    DataLine.Info info = new DataLine.Info(SourceDataLine.class,fmt);
    line = (SourceDataLine) AudioSystem.getLine(info);
    line.open(fmt);
    line.start();
    byte[] b = new byte[4410*5];
    double baseNote=A_NOTE;
    int pitch=0;
    for(;;) {
      for(int j=0;j<b.length/2;j++) {
        double note=baseNote;
        double value = 0;
        for(int i=0;i<6;i++) {
          if (pitch<6)
            value+=amplitudes[pitch][i]*Math.sin(j*(2.*Math.PI*note)/(FREQ))/50.;
          else
            value+=amplitudes[11-pitch][5-i]*Math.sin(j*(2.*Math.PI*note)/(FREQ))/50.;
          note=2*note;
        }
        putByte(b,2*j,value);
      }
      line.write(b,0,b.length);
      Thread.sleep(1000);
      if (pitch<11) {
        baseNote*=K;
        pitch++;
      }
      else {
        baseNote=A_NOTE;
        pitch=0;
      }
    }
  }

  // Gaussian
  private static final double[][] amplitudes = {{0.55,0.95,4.2,10.5,4.2,0.95},
    {0.6,1.1,4.85,10.45,4.2,0.9},
    {0.6,1.2,5.45,10.25,3.25,0.75},
    {0.6,1.3,6.1,9.85,2.8,0.8},
    {0.65,1.45,6.8,9.4,2.45,0.7},
    {0.65,1.65,7.5,8.85,2.1,0.7}};

}
